# coding=utf-8
'''
Created on 2017年9月12日
@vsersion:python 2.7
@author: liuyuqi
'''
import os
import random
import sys
from time import sleep

import cv2

out_dir = 'E:/data/workspace/faceisme/my_faces'
if not os.path.exists(out_dir):
    os.makedirs(out_dir)


# 改变亮度与对比度
def relight(img, alpha=1, bias=0):
    w = img.shape[1]
    h = img.shape[0]
    #image = []
    for i in range(0, w):
        for j in range(0, h):
            for c in range(3):
                tmp = int(img[j, i, c] * alpha + bias)
                if tmp > 255:
                    tmp = 255
                elif tmp < 0:
                    tmp = 0
                img[j, i, c] = tmp
    return img


# 获取人脸分类器
# D:\Program-Files\opencv\build\share\OpenCV\haarcascades\haarcascade_frontalface_default.xml
haar = cv2.CascadeClassifier('haarcascade_frontalface_default.xml')

# 打开摄像头 参数为输入流，可以为摄像头或视频文件
camera = cv2.VideoCapture(0)

n = 1
while 1:
    if (n <= 10000):
        print('It`s processing %s image.' % n)
        # 读帧
        success, img = camera.read()

# 转换为灰度图
        gray_img = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)
        # 调用detectMultiScale识别多张人脸，返回faces数组
        faces = haar.detectMultiScale(gray_img, 1.2, 5)
        if len(faces)>0:  
            for f_x, f_y, f_w, f_h in faces:
                face = img[f_y:f_y + f_h, f_x:f_x + f_w]
                # 标准化为64*64大小
                face = cv2.resize(face, (64, 64))
                '''
                if n % 3 == 1:
                    face = relight(face, 1, 50)
                elif n % 3 == 2:
                    face = relight(face, 0.5, 0)
                '''
                face = relight(face, random.uniform(
                    0.5, 1.5), random.randint(-50, 50))
                cv2.imshow('img', face)
                cv2.imwrite(out_dir + '/' + str(n) + '.jpg', face)
                n += 1
            key = cv2.waitKey(30) & 0xff
            if key == 27:
                break
        else:
            print("图片没有识别到faces")
    else:
        break
#     sleep(10)
